// ESP_now_RECEIVE.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>

typedef struct struct_message 
{char text[32];  int number;  float pi;  bool logic;} struct_message;
struct_message myData;

void OnDataRecv(const uint8_t *mac, const uint8_t *incomingData, int len) 
{ memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Bytes received: ");  Serial.println(len);
  Serial.print("Text: ");            Serial.println(myData.text);
  Serial.print("Message Number: ");  Serial.println(myData.number);
  Serial.print("Pi: ");              Serial.println(myData.pi,2);
  Serial.print("Bool: ");            Serial.println(myData.logic);
  Serial.println();
}
 
void setup() 
{ Serial.begin(115200); WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) { Serial.println("Error initializing ESP-NOW"); return; }
  esp_now_register_recv_cb(OnDataRecv);
}
 
void loop() {}
