// ESP_now_SEND.ino
// ESP32 @ IDE 1.8.16

#include <esp_now.h>
#include <WiFi.h>

// uint8_t broadcastAddress[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF}; // Use RECEIVER MAC Address here
uint8_t broadcastAddress[] = {0x80, 0x7D, 0x3A, 0xDC, 0x23, 0xBC};

int MessageNumber=1;

typedef struct struct_message 
{char text[32];  int number;  float pi;  bool logic;} struct_message;
struct_message myData; esp_now_peer_info_t peerInfo;

void OnDataSent(const uint8_t *mac_addr, esp_now_send_status_t status) 
{ Serial.println(status == ESP_NOW_SEND_SUCCESS ? "Delivery Success" : "Delivery Fail");}
 
void setup() 
{ Serial.begin(115200);  WiFi.mode(WIFI_STA);
  if (esp_now_init() != ESP_OK) { Serial.println("Error initializing ESP-NOW"); return; }
  esp_now_register_send_cb(OnDataSent);
  memcpy(peerInfo.peer_addr, broadcastAddress, 6); // six bytes for MAC
  peerInfo.channel = 0; peerInfo.encrypt = false;
  if (esp_now_add_peer(&peerInfo) != ESP_OK) { Serial.println("Failed to add peer"); return; }
}
 
void loop() 
{ strcpy(myData.text, "Hello from TX01");
         myData.number=MessageNumber;
         myData.pi=3.14;
         myData.logic=false;
  esp_err_t result=esp_now_send(broadcastAddress,(uint8_t *) &myData, sizeof(myData));
  Serial.print(result==ESP_OK ? "Data Sent \t" : "Send Fail \t");
  delay(1000);
  MessageNumber++;
}
